import { IgrToolActionCollection } from "./igr-tool-action-collection";
import { IgrToolAction } from "./igr-tool-action";
import { ToolActionCollection as ToolActionCollection_internal } from "./ToolActionCollection";
import { ToolAction } from "./ToolAction";
import { SyncableObservableCollection$1 } from "igniteui-react-core";
/**
 * Represents base class for all tool actions in menu
*/
export class IgrToolActionMenuBase extends IgrToolAction {
    constructor(props) {
        super(props);
        this._actions = null;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the data or data source instance to which to bind the grid.
    */
    get actions() {
        if (this._actions === null) {
            let coll = new IgrToolActionCollection();
            let innerColl = this.i.actions;
            if (!innerColl) {
                innerColl = new ToolActionCollection_internal();
            }
            this._actions = coll._fromInner(innerColl);
            this.i.actions = innerColl;
        }
        return this._actions;
    }
    set actions(v) {
        if (this._actions !== null) {
            this._actions._setSyncTarget(null);
            this._actions = null;
        }
        let coll = new IgrToolActionCollection();
        this._actions = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(ToolAction.$type);
        let innerColl = this.i.actions;
        if (!innerColl) {
            innerColl = new ToolActionCollection_internal();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._actions._setSyncTarget(syncColl);
        this.i.actions = innerColl;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.actions != null && this.actions.findByName && this.actions.findByName(name)) {
            return this.actions.findByName(name);
        }
        return null;
    }
    fromInfo(info) {
        this.i.a9(info);
    }
}
