import { __extends } from "tslib";
import { IgrToolActionCollection } from "./igr-tool-action-collection";
import { IgrToolAction } from "./igr-tool-action";
import { ToolActionCollection as ToolActionCollection_internal } from "./ToolActionCollection";
import { ToolAction } from "./ToolAction";
import { SyncableObservableCollection$1 } from "igniteui-react-core";
/**
 * Represents base class for all tool actions in menu
*/
var IgrToolActionMenuBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrToolActionMenuBase, _super);
    function IgrToolActionMenuBase(props) {
        var _this = _super.call(this, props) || this;
        _this._actions = null;
        return _this;
    }
    Object.defineProperty(IgrToolActionMenuBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionMenuBase.prototype, "actions", {
        /**
         * Gets or sets the data or data source instance to which to bind the grid.
        */
        get: function () {
            if (this._actions === null) {
                var coll = new IgrToolActionCollection();
                var innerColl = this.i.actions;
                if (!innerColl) {
                    innerColl = new ToolActionCollection_internal();
                }
                this._actions = coll._fromInner(innerColl);
                this.i.actions = innerColl;
            }
            return this._actions;
        },
        set: function (v) {
            if (this._actions !== null) {
                this._actions._setSyncTarget(null);
                this._actions = null;
            }
            var coll = new IgrToolActionCollection();
            this._actions = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(ToolAction.$type);
            var innerColl = this.i.actions;
            if (!innerColl) {
                innerColl = new ToolActionCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._actions._setSyncTarget(syncColl);
            this.i.actions = innerColl;
        },
        enumerable: false,
        configurable: true
    });
    IgrToolActionMenuBase.prototype.findByName = function (name) {
        var baseResult = _super.prototype.findByName.call(this, name);
        if (baseResult) {
            return baseResult;
        }
        if (this.actions != null && this.actions.findByName && this.actions.findByName(name)) {
            return this.actions.findByName(name);
        }
        return null;
    };
    IgrToolActionMenuBase.prototype.fromInfo = function (info) {
        this.i.a9(info);
    };
    return IgrToolActionMenuBase;
}(IgrToolAction));
export { IgrToolActionMenuBase };
