import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ListPanel } from "./ListPanel";
import { Size } from "igniteui-react-core";
import { Popup } from "igniteui-react-core";
import { NativeUIContent } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { ToolActionType } from "igniteui-react-core";
import { ToolCommandArgument } from "igniteui-react-core";
import { ListPanelTemplateItemUpdatingEventArgs } from "./ListPanelTemplateItemUpdatingEventArgs";
import { ToolActionMeasurementContext } from "./ToolActionMeasurementContext";
import { ToolCommand } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ToolCommandEventArgs } from "./ToolCommandEventArgs";
import { ToolActionInfo } from "igniteui-react-core";
import { ToolPanelOrientation } from "./ToolPanelOrientation";
import { NativeUIGrid } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { ToolPanelContentRefreshedEventArgs } from "./ToolPanelContentRefreshedEventArgs";
import { IExecutionContext } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class ToolPanelView extends Base {
    static $t: Type;
    private p;
    private o;
    constructor();
    r(): any;
    c: ToolPanel;
    x(): void;
    k: DomRenderer;
    n: DomWrapper;
    g: RenderingContext;
    m: DomWrapper;
    v(a: DomRenderer): void;
    aa(): void;
    z(): void;
    u(): void;
    ab(): void;
    private d;
    private ad;
    private e;
    private _gridExternal;
    f(): FontInfo;
    w(): void;
    y(): void;
    t(): void;
    i(): number;
    j(a: string): number;
    h: boolean;
    private l;
    s(a: any, b: (arg1: any) => void): void;
    a(): Popup;
    b(a: NativeUIContent): ToolPanel;
    ac(a: any): Rect;
}
/**
 * @hidden
 */
export declare class ToolAction extends Base implements INotifyPropertyChanged {
    static $t: Type;
    e: ToolPanel;
    get ar(): string;
    private a4;
    b(a: boolean): ToolActionEventDetail;
    i(): ToolCommandArgument;
    a2(): string;
    y(): any;
    z(): any;
    private ag;
    get a0(): string;
    set a0(a: string);
    a3(): string;
    private ab;
    get al(): string;
    set al(a: string);
    private aa;
    get ai(): string;
    set ai(a: string);
    private w;
    get x(): any;
    set x(a: any);
    private f;
    get g(): BaseControlTheme;
    set g(a: BaseControlTheme);
    private m;
    get t(): number;
    set t(a: number);
    private n;
    get u(): number;
    set u(a: number);
    private l;
    get s(): number;
    set s(a: number);
    private o;
    get v(): number;
    set v(a: number);
    get k(): boolean;
    private af;
    get au(): string;
    set au(a: string);
    private ae;
    get as(): string;
    set as(a: string);
    private ad;
    get ap(): string;
    set ap(a: string);
    private ac;
    get an(): string;
    set an(a: string);
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected bb(a: string, b: any, c: any): void;
    protected get_h(): ToolActionType;
    get h(): ToolActionType;
    protected bf(a: string, b: any, c: any): void;
    bh(): void;
    bd(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
    be(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
    a7(a: ToolPanel, b: ToolActionMeasurementContext): void;
    a8(a: ToolPanel, b: ToolActionMeasurementContext): void;
    q(a: ToolPanel, b: ToolActionMeasurementContext): number;
    r(a: ToolPanel, b: ToolActionMeasurementContext): number;
    p(a: ToolPanel, b: ToolActionMeasurementContext): number;
    bc(a: ToolActionEventDetail, b: ToolAction): void;
    private bg;
    onCommand: (sender: any, args: ToolCommandEventArgs) => void;
    private a5;
    j(): boolean;
    private ba;
    private a6;
    performed: (sender: any, args: ToolActionPerformedEventArgs) => void;
    static a(a: ToolActionInfo): ToolAction;
    a9(a: ToolActionInfo): void;
}
/**
 * @hidden
 */
export declare class ToolActionButton extends ToolAction {
    static $t: Type;
    protected get_h(): ToolActionType;
    i(): ToolCommandArgument;
    b(a: boolean): ToolActionEventDetail;
    private bi;
    r(a: ToolPanel, b: ToolActionMeasurementContext): number;
    q(a: ToolPanel, b: ToolActionMeasurementContext): number;
    private bk;
    private bj;
    be(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare class ToolActionLabel extends ToolAction {
    static $t: Type;
    protected get_h(): ToolActionType;
    private bj;
    private bi;
    be(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare class ToolActionRadio extends ToolAction {
    static $t: Type;
    protected get_h(): ToolActionType;
    private bj;
    get bk(): string;
    set bk(a: string);
    b(a: boolean): ToolActionEventDetail;
    z(): any;
    bl(): void;
    private bi;
    q(a: ToolPanel, b: ToolActionMeasurementContext): number;
    bh(): void;
    private bn;
    private bm;
    be(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare class ToolActionSeparator extends ToolAction {
    static $t: Type;
    protected get_h(): ToolActionType;
    a8(a: ToolPanel, b: ToolActionMeasurementContext): void;
    private bi;
    be(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare class ToolActionIconButton extends ToolAction {
    static $t: Type;
    protected get_h(): ToolActionType;
    i(): ToolCommandArgument;
    b(a: boolean): ToolActionEventDetail;
    private bi;
    q(a: ToolPanel, b: ToolActionMeasurementContext): number;
    bh(): void;
    private bk;
    private bj;
    be(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare class ToolActionGroupHeader extends ToolAction {
    static $t: Type;
    protected get_h(): ToolActionType;
    private bi;
    be(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare abstract class ToolActionMenuBase extends ToolAction {
    static $t: Type;
    i(): ToolCommandArgument;
    a9(a: ToolActionInfo): void;
    constructor();
    private bu;
    private bz;
    private bl;
    get actions(): ToolActionCollection;
    set actions(a: ToolActionCollection);
    b(a: boolean): ToolActionEventDetail;
    private bq;
    private bi;
    private bo;
    private bp;
    protected b0(): void;
    private b1;
    private bj;
    private bk;
    protected abstract b2(): Rect;
    private by;
    private bx;
    private bn;
    private bs;
    private br;
    private bw;
    private bv;
}
/**
 * @hidden
 */
export declare class ToolActionIconMenu extends ToolActionMenuBase {
    static $t: Type;
    protected get_h(): ToolActionType;
    private b3;
    q(a: ToolPanel, b: ToolActionMeasurementContext): number;
    protected b2(): Rect;
    private b5;
    private b4;
    be(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare class ToolActionCheckbox extends ToolAction {
    static $t: Type;
    protected get_h(): ToolActionType;
    b(a: boolean): ToolActionEventDetail;
    z(): any;
    private bi;
    q(a: ToolPanel, b: ToolActionMeasurementContext): number;
    private bk;
    private bj;
    be(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare class ToolActionNumberInput extends ToolAction {
    static $t: Type;
    protected get_h(): ToolActionType;
    z(): any;
    private bi;
    q(a: ToolPanel, b: ToolActionMeasurementContext): number;
    bh(): void;
    private bl;
    bj(): number;
    b(a: boolean): ToolActionEventDetail;
    private bk;
    be(a: ListPanel, b: ToolPanel, c: ListPanelTemplateItemUpdatingEventArgs, d: ToolActionMeasurementContext): void;
}
/**
 * @hidden
 */
export declare class ToolActionCollection extends ObservableCollection$1<ToolAction> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class ToolActionPerformedEventArgs extends Base {
    static $t: Type;
    constructor();
    c: boolean;
    a: ToolActionEventDetail;
    b: ToolActionEventDetailCollection;
}
/**
 * @hidden
 */
export declare class ToolActionEventDetail extends Base {
    static $t: Type;
    a: ToolAction;
    b: ToolActionType;
    d: boolean;
    c: boolean;
    f: number;
    e: Date;
    g: any;
}
/**
 * @hidden
 */
export declare class ToolActionEventDetailCollection extends ObservableCollection$1<ToolActionEventDetail> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class ToolPanel extends Base implements INotifyPropertyChanged {
    static $t: Type;
    l: ToolPanelView;
    r: NativeUIGrid;
    private u;
    private s;
    private get t();
    at(a: ListPanel): void;
    private aj;
    private ak;
    private al;
    private f;
    private am;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private d;
    az(a: Size): void;
    contentRefreshed: (sender: any, args: ToolPanelContentRefreshedEventArgs) => void;
    get actions(): ToolActionCollection;
    set actions(a: ToolActionCollection);
    constructor();
    private an;
    private ay;
    private v;
    protected a5(): void;
    private aq;
    private y;
    private z;
    private x;
    private ao;
    w(a: ToolAction): boolean;
    c(a: string): ToolAction;
    aa(a: ToolAction): List$1<ToolAction>;
    private av;
    private a2;
    private aw;
    private a7;
    private ar;
    as(): void;
    a6(a: ToolAction): void;
    private au;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private o;
    get p(): FontInfo;
    set p(a: FontInfo);
    q(): FontInfo;
    protected a0(a: string, b: any, c: any): void;
    protected a3(a: string, b: any, c: any): void;
    private a8;
    a: IExecutionContext;
    private m;
    get n(): BaseControlTheme;
    set n(a: BaseControlTheme);
    static bc: Brush;
    private a9;
    get bb(): Brush;
    set bb(a: Brush);
    static bd: Brush;
    ba: Brush;
    private b;
    private ab;
    get be(): Brush;
    set be(a: Brush);
    static j: ToolPanelOrientation;
    private i;
    get k(): ToolPanelOrientation;
    set k(a: ToolPanelOrientation);
    a1(a: ToolAction, b: ToolCommand): void;
    onCommand: (sender: any, args: ToolCommandEventArgs) => void;
}
