import { IgrToolActionCollection } from "./igr-tool-action-collection";
import { IgrToolAction, IIgrToolActionProps } from "./igr-tool-action";
import { ToolActionMenuBase } from "./ToolActionMenuBase";
import { ToolActionInfo } from "igniteui-react-core";
/**
 * Represents base class for all tool actions in menu
*/
export declare abstract class IgrToolActionMenuBase<P extends IIgrToolActionMenuBaseProps = IIgrToolActionMenuBaseProps> extends IgrToolAction<P> {
    /**
                                 * @hidden
                                 */
    get i(): ToolActionMenuBase;
    constructor(props: P);
    private _actions;
    /**
     * Gets or sets the data or data source instance to which to bind the grid.
    */
    get actions(): IgrToolActionCollection;
    set actions(v: IgrToolActionCollection);
    findByName(name: string): any;
    fromInfo(info: ToolActionInfo): void;
}
export interface IIgrToolActionMenuBaseProps extends IIgrToolActionProps {
    /**
     * Gets or sets the data or data source instance to which to bind the grid.
    */
    actions?: IgrToolActionCollection | string;
}
