import * as React from 'react';
import { BaseControlTheme } from "igniteui-react-core";
import { IgrToolCommandEventArgs } from "./igr-tool-command-event-args";
import { IgrToolActionPerformedEventArgs } from "./igr-tool-action-performed-event-args";
import { ToolAction } from "./ToolAction";
import { ToolActionInfo } from "igniteui-react-core";
/**
 * Represents base class for all tool actions in toolbar
*/
export declare class IgrToolAction<P extends IIgrToolActionProps = IIgrToolActionProps> extends React.Component<P, {}> {
    protected createImplementation(): ToolAction;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): ToolAction; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrToolAction;
    private onImplementationCreated;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): any;
    get id(): string;
    get parentId(): string;
    set parentId(v: string);
    get commandId(): string;
    set commandId(v: string);
    get commandArgument(): string;
    set commandArgument(v: string);
    get commandArgumentValue(): any;
    set commandArgumentValue(v: any);
    /**
     * Gets or sets the base built in theme to use for the checkbox.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    get paddingLeft(): number;
    set paddingLeft(v: number);
    get paddingRight(): number;
    set paddingRight(v: number);
    get paddingBottom(): number;
    set paddingBottom(v: number);
    get paddingTop(): number;
    set paddingTop(v: number);
    get name(): string;
    set name(v: string);
    get label(): string;
    set label(v: string);
    get iconName(): string;
    set iconName(v: string);
    get iconCollectionName(): string;
    set iconCollectionName(v: string);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    fromInfo(info: ToolActionInfo): void;
    private _onCommand;
    private _onCommand_wrapped;
    get onCommand(): (s: IgrToolAction, e: IgrToolCommandEventArgs) => void;
    set onCommand(ev: (s: IgrToolAction, e: IgrToolCommandEventArgs) => void);
    private _performed;
    private _performed_wrapped;
    get performed(): (s: IgrToolAction, e: IgrToolActionPerformedEventArgs) => void;
    set performed(ev: (s: IgrToolAction, e: IgrToolActionPerformedEventArgs) => void);
}
export interface IIgrToolActionProps {
    children?: React.ReactNode;
    parentId?: string;
    commandId?: string;
    commandArgument?: string;
    commandArgumentValue?: any;
    /**
     * Gets or sets the base built in theme to use for the checkbox.
    */
    baseTheme?: BaseControlTheme | string;
    paddingLeft?: number | string;
    paddingRight?: number | string;
    paddingBottom?: number | string;
    paddingTop?: number | string;
    name?: string;
    label?: string;
    iconName?: string;
    iconCollectionName?: string;
    onCommand?: (s: IgrToolAction, e: IgrToolCommandEventArgs) => void;
    performed?: (s: IgrToolAction, e: IgrToolActionPerformedEventArgs) => void;
}
