import * as React from 'react';
import { ToolPanel } from './ToolPanel';
import { BaseControlTheme } from "igniteui-react-core";
import { ToolPanelOrientation } from './ToolPanelOrientation';
import { IgrToolActionCollection } from "./igr-tool-action-collection";
import { IgrToolPanelContentRefreshedEventArgs } from "./igr-tool-panel-content-refreshed-event-args";
import { IgrToolAction } from './igr-tool-action';
import { IgrToolCommandEventArgs } from './igr-tool-command-event-args';
export declare class IgrToolPanel extends React.Component<IIgrToolPanelProps> {
    private _implementation;
    private _reactRenderer;
    private _height;
    private _width;
    private _initialized;
    private _elRef;
    private _portalManager;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _getMainRef;
    private _contentChildrenManager;
    private _updateContentChildren;
    contentActions: IgrToolAction[];
    /**
    * The style mappings actually present in the treemap. Do not directly modify this array.
    * This array's contents can be modified by causing React to reproject the child content.
    * Or adding and removing ranges from the manual ranges collection on the ranges property.
    */
    actualActions: IgrToolAction[];
    private _actions;
    private _actionsAdapter;
    /**
     * A collection of manually added style mappings for the treemap.
    */
    get actions(): IgrToolActionCollection;
    render(): React.DetailedReactHTMLElement<{
        ref: (ref: any) => void;
        className: string;
        children: any[];
    }, any>;
    private verifyReferences;
    private requestRender;
    constructor(props: IIgrToolPanelProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): ToolPanel;
    get i(): ToolPanel;
    /**
 * Gets or Sets the property name that contains the values.
*/
    get cellTextStyle(): string;
    set cellTextStyle(v: string);
    /**
     * Gets or sets the base built in theme to use for the checkbox.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or sets the color to use for the text of the component.
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get orientation(): ToolPanelOrientation;
    set orientation(v: ToolPanelOrientation);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    private _contentRefreshed;
    private _contentRefreshed_wrapped;
    get contentRefreshed(): (s: IgrToolPanel, e: IgrToolPanelContentRefreshedEventArgs) => void;
    set contentRefreshed(ev: (s: IgrToolPanel, e: IgrToolPanelContentRefreshedEventArgs) => void);
    private _onCommand;
    private _onCommand_wrapped;
    get onCommand(): (s: IgrToolPanel, e: IgrToolCommandEventArgs) => void;
    set onCommand(ev: (s: IgrToolPanel, e: IgrToolCommandEventArgs) => void);
}
export interface IIgrToolPanelProps {
    width?: string;
    height?: string;
    children?: React.ReactNode;
    actions?: IgrToolActionCollection;
    /**
 * Gets or Sets the property name that contains the values.
*/
    cellTextStyle?: string;
    /**
     * Gets or sets the base built in theme to use for the checkbox.
    */
    baseTheme?: BaseControlTheme | string;
    /**
     * Gets or sets the color to use for the background of the component.
    */
    backgroundColor?: string;
    /**
     * Gets or sets the color to use for the text of the component.
    */
    textColor?: string;
    /**
     * Gets or sets the color to use for the background of the component.
    */
    orientation?: ToolPanelOrientation | string;
    contentRefreshed?: (s: IgrToolPanel, e: IgrToolPanelContentRefreshedEventArgs) => void;
    onCommand?: (s: IgrToolPanel, e: IgrToolCommandEventArgs) => void;
}
