import * as React from 'react';
import { Toolbar } from './Toolbar';
import { BaseControlTheme } from "igniteui-react-core";
import { ToolbarOrientation } from './ToolbarOrientation';
import { IgrToolActionCollection } from "./igr-tool-action-collection";
import { IgrToolAction } from './igr-tool-action';
export declare class IgrToolbar extends React.Component<IIgrToolbarProps> {
    private _implementation;
    private _reactRenderer;
    private _height;
    private _width;
    private _initialized;
    private _elRef;
    private _portalManager;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _getMainRef;
    private _contentChildrenManager;
    private _updateContentChildren;
    contentActions: IgrToolAction[];
    /**
    * The style mappings actually present in the treemap. Do not directly modify this array.
    * This array's contents can be modified by causing React to reproject the child content.
    * Or adding and removing ranges from the manual ranges collection on the ranges property.
    */
    combinedActions: IgrToolAction[];
    private _actions;
    private _actionsAdapter;
    /**
     * A collection of manually added style mappings for the treemap.
    */
    get actions(): IgrToolActionCollection;
    render(): React.DetailedReactHTMLElement<{
        ref: (ref: any) => void;
        className: string;
        children: any[];
    }, any>;
    private verifyReferences;
    private requestRender;
    constructor(props: IIgrToolbarProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): Toolbar;
    get i(): Toolbar;
    /**
 * Gets or sets the base built in theme to use for the checkbox.
*/
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    private _autoGeneratedActions;
    /**
     * Gets or sets the data or data source instance to which to bind the grid.
    */
    get autoGeneratedActions(): IgrToolActionCollection;
    set autoGeneratedActions(v: IgrToolActionCollection);
    private _actualActions;
    /**
     * Gets or sets the data or data source instance to which to bind the grid.
    */
    get actualActions(): IgrToolActionCollection;
    set actualActions(v: IgrToolActionCollection);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get orientation(): ToolbarOrientation;
    set orientation(v: ToolbarOrientation);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get target(): any;
    set target(v: any);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or sets the color to use for the text of the component.
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get cellTextStyle(): string;
    set cellTextStyle(v: string);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
}
export interface IIgrToolbarProps {
    width?: string;
    height?: string;
    children?: React.ReactNode;
    actions?: IgrToolActionCollection;
    /**
 * Gets or sets the base built in theme to use for the checkbox.
*/
    baseTheme?: BaseControlTheme | string;
    /**
     * Gets or sets the data or data source instance to which to bind the grid.
    */
    autoGeneratedActions?: IgrToolActionCollection | string;
    /**
     * Gets or sets the data or data source instance to which to bind the grid.
    */
    actualActions?: IgrToolActionCollection | string;
    /**
     * Gets or sets the color to use for the background of the component.
    */
    orientation?: ToolbarOrientation | string;
    /**
     * Gets or sets the color to use for the background of the component.
    */
    target?: any;
    /**
     * Gets or sets the color to use for the background of the component.
    */
    backgroundColor?: string;
    /**
     * Gets or sets the color to use for the text of the component.
    */
    textColor?: string;
    /**
     * Gets or Sets the property name that contains the values.
    */
    cellTextStyle?: string;
}
